unit UnitMain;

interface

uses System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs, FMXTee.Control,
  FMXTee.Grid, Tee.GridData.Rtti, Tee.Grid.Columns;

type tData = record
  Id: Integer;
  Name: string;
end;

type TDataArray = tArray<tData>;

type
  TFrmDemo = class(TForm)
    tgrdSlave: TTeeGrid;
    tgrdMain: TTeeGrid;
    procedure FormCreate(Sender: TObject);
    procedure tgrdMainSelect(Sender: TObject);
  private
    MainSlaveData: TDataArray;
    slaveDataArray: TArray<TDataArray>;
    procedure GetSlaveData;
    procedure SetSlaveData;

  public
    MaingridData: TDataArray;
    Slave0Data: TDataArray;
    Slave1Data: TDataArray;
    Slave2Data: TDataArray;
    Slave3Data: TDataArray;
  end;

var FrmDemo: TFrmDemo;

implementation

{$R *.fmx}

procedure TFrmDemo.FormCreate(Sender: TObject);
begin
  SetLength(MaingridData, 4);
  MaingridData[0].Id:= 1; MaingridData[0].Name:= 'FIRST';
  MaingridData[1].Id:= 2; MaingridData[1].Name:= 'SECOND';
  MaingridData[2].Id:= 3; MaingridData[2].Name:= 'THIRD';
  MaingridData[3].Id:= 4; MaingridData[3].Name:= 'Neljas';
  SetLength(Slave0Data, 4);
  Slave0Data[0].Id:= 1; Slave0Data[0].Name:= 'FIRST Slave0';
  Slave0Data[1].Id:= 2; Slave0Data[1].Name:= 'SECOND Slave0';
  Slave0Data[2].Id:= 3; Slave0Data[2].Name:= 'THIRD Slave0';
  Slave0Data[3].Id:= 4; Slave0Data[3].Name:= 'Neljas Slave0';
  SetLength(Slave1Data, 4);
  Slave1Data[0].Id:= 1; Slave1Data[0].Name:= 'FIRST Slave1';
  Slave1Data[1].Id:= 2; Slave1Data[1].Name:= 'SECOND Slave1';
  Slave1Data[2].Id:= 3; Slave1Data[2].Name:= 'THIRD Slave1';
  Slave1Data[3].Id:= 4; Slave1Data[3].Name:= 'Neljas Slave1';
  SetLength(Slave2Data, 4);
  Slave2Data[0].Id:= 1; Slave2Data[0].Name:= 'FIRST Slave2';
  Slave2Data[1].Id:= 2; Slave2Data[1].Name:= 'SECOND Slave2';
  Slave2Data[2].Id:= 3; Slave2Data[2].Name:= 'THIRD Slave2';
  Slave2Data[3].Id:= 4; Slave2Data[3].Name:= 'Neljas Slave2';
  SetLength(Slave3Data, 0);
//  Slave3Data[0].Id:= 1; Slave3Data[0].Name:= 'FIRST Slave3';
//  Slave3Data[1].Id:= 2; Slave3Data[1].Name:= 'SECOND Slave3';
//  Slave3Data[2].Id:= 3; Slave3Data[2].Name:= 'THIRD Slave3';
//  Slave3Data[3].Id:= 4; Slave3Data[3].Name:= 'Neljas Slave3';

  SetLength(slaveDataArray,4);
  slaveDataArray[0]:=Slave0Data;
  slaveDataArray[1]:=Slave1Data;
  slaveDataArray[2]:=Slave2Data;
  slaveDataArray[3]:=Slave3Data;

  Try
    tgrdMain.Data:= TVirtualData<TDataArray>.Create(MaingridData);
  Except End;
end;

procedure TFrmDemo.GetSlaveData;
begin
  if NOT (tgrdMain.Selected.Row in [0..3]) then Exit;

  SetSlaveData;
end;

procedure TFrmDemo.tgrdMainSelect(Sender: TObject);
begin
  GetSlaveData;
end;

procedure TFrmDemo.SetSlaveData;
begin
  tgrdSlave.Data:=TVirtualData<TDataArray>.Create(slaveDataArray[tgrdMain.Selected.Row]);
end;
end.
